package esercitazione2.lists;

public class ListOfInteger {

	private ListItemOfInteger head;
	
	ListOfInteger(){
		
		ListItemOfInteger sentinel = new ListItemOfInteger(null);
		
		this.head = sentinel;
		
	}
	
	public Boolean insertAt(Integer position, Integer n){
		
		Integer counter = 1;
		Boolean inserted = false;
		Boolean finished = false;
		ListItemOfInteger pointer = this.head;
				
		while (!inserted && !finished) {
			
			if (counter == position) {
				
				ListItemOfInteger tmp = new ListItemOfInteger(n);
				
				tmp.setNext(pointer.getNext());
				pointer.setNext(tmp);
				inserted = true;
			}
			else {
				pointer = pointer.getNext();
				counter++;
				
				if (pointer == null)
					finished = true;
			}
			
		}
		
		return inserted;
		
	}
	

	
public Boolean removeAt(Integer position){
		
		Integer counter = 1;
		Boolean removed = false;
		Boolean finished = false;
		
		ListItemOfInteger pointer = this.head;
		
		while ((counter < position) && !finished) {
			counter++;
			pointer = pointer.getNext();
			
			if (pointer.getNext() == null)
				finished = true;
			
		}
		
		if ((counter == position) && !finished){
			
			ListItemOfInteger tmp = pointer.getNext(); 
			pointer.setNext(tmp.getNext());
			removed = true;
		}
		
		return removed;
}
	

      public void printAll(){
    	  
    	  ListItemOfInteger p = this.head.getNext();
    	  
    	  System.out.println();
    	  while (p != null) {
    		  System.out.print(p.getValue() + " ");
    		  p = p.getNext();
    	  }
    	  
      }


}
