package esercitazione2.stack;

public class Stack<T> {

	StackItem<T> top;
	
	public Stack() {
		this.top = null;
	}
	
	public Boolean isEmpty(){
		return (this.top == null);
	}
	
	public void push(T e){
		
		StackItem<T> newItem = new StackItem<T>(e);
		
		newItem.setNext(this.top);
		this.top = newItem;
	}
	
	
	public void pop(){
		
		StackItem<T> topToBeRemoved = this.top;
		
		if (topToBeRemoved != null)
			this.top = topToBeRemoved.getNext();
		
	}

}
